<template>
  <Popup ref="pop" :title="form.title" left="calc(100% - 330px)">
    <div class="terrainDig">
      <el-form ref="form" :model="form" label-width="100px">
        <el-form-item label="深度(米):">
          <el-input-number
            v-model="form.depth"
            controls-position="right"
            @change="handleChange"
            :min="1"
          ></el-input-number>
        </el-form-item>
        <!-- <el-form-item label="添加墙体:">
          <el-switch v-model="form.showWall"></el-switch>
        </el-form-item> -->
        <el-form-item>
          <el-button type="primary" size="mini" @click="dig">绘制</el-button>
          <!-- <el-upload
            class="button-group"
            action=""
            :auto-upload="false"
            :show-file-list="false"
            :on-change="inputDig"
            accept=".json"
          >
          <el-button type="primary" size="mini" slot="trigger"
              >导入</el-button
            >
          </el-upload> -->
        </el-form-item>
      </el-form>
    </div>
  </Popup>
</template>
<script>
import Popup from './Popup.vue';

export default {
  name: 'terrainDig',
  components: {
    Popup,
  },
  data() {
    return {
      form: {
        title: '地形开挖',
        depth: 50,
        showWall: true,
      },
    };
  },
  computed: {},
  mounted() {},
  methods: {
    // 关闭弹窗
    close() {
      this.$refs.pop.close();
    },
    // 打开弹窗
    open() {
      this.$refs.pop.open();
    },
    // 输入框数据修改
    handleChange(value) {
      if (Excavation) {
        Excavation.setDeepth(value);
      }
    },
    // 地形开挖
    dig() {
      window.Excavation = sgworld.Analysis.TerrainExcavation(
        this.form.depth,
        {
          showWall: this.form.showWall,
        },
        (degreesArr) => {
          this.addToTree(Excavation, degreesArr);
        }
      );
    },
    inputDig(file) {
      let reader = new FileReader();
      reader.onload = (e) => {
        let data = JSON.parse(e.target.result);
        data &&
          data.forEach((item) => {
            let degreesArr = [];
            item.polygon.forEach((p) => {
              degreesArr.push(...p);
            });
            let length = degreesArr.length;
            if (
              degreesArr[0] === degreesArr[length - 3] &&
              degreesArr[1] === degreesArr[length - 2]
            ) {
              degreesArr.splice(length - 3, 3);
            }
            Excavation = sgworld.Analysis.TerrainExcavation(this.form.depth, {
              positions: degreesArr,
              showWall: this.form.showWall,
            });
            this.addToTree(Excavation, degreesArr);
          });
        this.$message('开挖区域已导入');
      };
      reader.readAsText(file.raw);
    },
    addToTree(excavation, degreesArr) {
      let data = {
        id: sgworld.Core.getuid(),
        name: '新建地形开挖',
        sourceType: 'excavate',
        item: excavation,
        depth: this.form.depth,
        showWall: this.form.showWall,
        positions: degreesArr,
      };
      // this.$parent.addAnalyseToTree(data);
    },
  },
};
</script>
<style lang="less">
.terrainDig {
  .el-input-number {
    width: 180px !important;
  }
  .el-button {
    margin-left: 10px;
    padding: 12px 30px;
  }
  .button-group {
    text-align: center;
    margin-top: 12px;
  }
  .el-form-item {
    margin-bottom: 10px;
  }
}
</style>
